/*
CARTSTORE

Ostoskori on laitettu omaan storeensa. Ostoskori on pelkästään 
muistissa, eikä sitä tallenneta pysyvästi mihinkään. Oikeassa 
kaupassa tallennus esim. localstoreen olisi suositeltavaa, siltä 
varalta, että käyttäjä onnistuisi hävittämään ostoskorin muistista 
kesken ostostapahtuman.

Cartstoren tietotyyppi on samanlainen kuin productstoren, mutta
storejen tilat ovat erilaiset. Koska tiedot ovat tyypiltään samat,
voi tietoja käsitellä samantapaisilla metodeilla molemmissa storeissa.
*/

import { signalStore, withComputed, withMethods, withState } from "@ngrx/signals";
import { Cart } from "./types";
import { computed } from "@angular/core";

// aluksi ostoskori on tyhjä
const initialState: Cart = {
  products: [],
};
/*
CartStore on funktionaalinen store, eli funktio,
jonka argumentteina on funktioita ja olioita
*/
export const CartStore = signalStore(
  { providedIn: 'root' },
  withState(initialState),

  /*
  withComputed-funktio sisältää anonyymin funktion, joka sisältää computed-metodit, 
  eli metodit joilla voidaan tehdä esim. laskutoimituksia storen sisällöstä.
  */
   // Tee metodit
   // totalcount: lasketaan tuotteiden kokonaismäärä amount-avaimien arvoista
   // totalsum: lasketaan tuotteiden hintojen summa storessa totalprice-avaimien arvoista
  withComputed(({ products }) => ({

   
  })),
  
   /* withMethods-funktio sisältää anonyymin funktion, joka sisältää 
   storen varsinaiset tietoa käsittelevät metodit */   
  // Tee metodit
   // addToCart
   // removeFromCart
   // removeItem
   // increment
   // decrement
  withMethods(({ products, ...store }) => ({

  
  }))

);
