import { InMemoryDbService } from 'angular-in-memory-web-api';
import { Injectable } from '@angular/core';
import { Product } from './types'; // tuotteen tyyppi

@Injectable({
  providedIn: 'root',
})
export class InMemoryDataService implements InMemoryDbService {
  createDb() {
    // products-taulukko on valetietokanta, jossa ovat tuotteet
    const products: Product[] = [
      { id: 1, name: 'Karvalakki', price: 10, amount: 200, totalprice: 2000 },
      { id: 2, name: 'Lumilapio', price: 20, amount: 100, totalprice: 2000 },
      { id: 3, name: 'Potkukelkka', price: 100, amount: 50, totalprice: 5000 },
    ];
    return {products};
  }

  // Jos luodaan uusi tuote, niin genId-metodi generoi uudelle tuotteelle id:n
  genId(products: Product[]): number {
    return products.length > 0
      ? Math.max(...products.map((prod) => prod.id)) + 1
      : 1;
  }
}
